package PktDump::Analyser::PPPoEsession;

use strict;
use warnings;

use base qw( PktDump::Analyser );

use constant ETHERTYPE => 0x8864;

use PktDump::Filter;
use PktDump::Analyser::PPP;

sub analyse
{
   my $self = shift;
   my ( $pkt, $opts ) = @_;

   my ( $vertype, $code, $session, $len, $data ) = unpack( "C C n n a*", $pkt );

   if( $opts->{one_line} ) {
      return "PPPoE| " . PktDump::Analyser::PPP->analyse( $data, $opts );
   }
   else {
      my @lines = sprintf "PPPoE| session=%04x", $session;
      push @lines, PktDump::Analyser::PPP->analyse( $data, $opts );
      return @lines;
   }
}

1;
